'\"
'\" Soar man page 
'\"
.so man.macros
.HS aliases soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
Soar aliases

.SH DESCRIPTION
.PP
There are a number of command aliases that are provided by Soar.
These are used to provide short versions of built in commands
and to provide syntactic continuity with previous versions of
Soar.  Soar provides a predefined set of aliases that will be
useful to most users.  Soar also provides a set of aliases to 
aid Soar 6 users.
.PP
These aliases are equivalent to an existing built in command
and (possibly) a set of switches for the command.  Additional
arguments given after the alias are passed on to the built in
command.
.PP
The predefined aliases are:
.RS
.TP
\fB?\fR
A short form of the \fBhelp\fR command.
.TP
\fBwmem\fR
Prints the contents of working memory.  It is equivalent to 
\fBprint -depth 0 -internal\fR.
.PP
.RE
.PP
The Soar 6 compatibility aliases are:
.RS
.TP
\fBcreate-agent\fR
Equivalent to \fBcreate-interp -agent\fR.
.TP
\fBdestroy-agent\fR
Equivalent to \fBdestroy-interp\fR.
.TP
\fBexcise-all\fR
Equivalent to \fBexcise -all\fR.
.TP
\fBexcise-chunks\fR
Equivalent to \fBexcise -chunks\fR.
.TP
\fBexcise-task\fR
Equivalent to \fBexcise -task\fR.
.TP
\fBlist-agents\fR
Equivalent to \fBlist-interps -agent\fR.
.TP
\fBlist-chunks\fR
Equivalent to \fBlist-productions -chunk\fR.
.TP
\fBlist-help-topics\fR
Equivalent to \fBhelp -all\fR.
.TP
\fBlist-justifications\fR
Equivalent to \fBlist-productions -justification\fR.
.TP
\fBload\fR
Equivalent to \fBsource\fR
.TP
\fBmemory-stats\fR
Equivalent to \fBstats -memory\fR
.TP
\fBobject-trace-format\fR
Equivalent to \fBformat-watch -object\fR
.TP
\fBp\fR
Equivalent to \fBprint\fR
.TP
\fBpgs\fR
Equivalent to \fBprint -stack\fR
.TP
\fBprint-stats\fR
Equivalent to \fBstats\fR
.TP
\fBrete-stats\fR
Equivalent to \fBstats -rete\fR
.TP
\fBr\fR
Equivalent to \fBrun\fR
.TP
\fBselect-agent\fR
Equivalent to \fBselect-interp\fR
.TP
\fBspr\fR
Equivalent to \fBprint\fR
.TP
\fBstack-trace-format\fR
Equivalent to \fBformat-watch -stack\fR
.RE

.SH FILES
.PP
All alias definition files are in the Soar Tcl library directory.
The predefined aliases are included in the startup file 
\fBsoar.tcl\fR.  The Soar 6 compatibility aliases are in 
\fBalias-soar6.tcl\fR.  The predefined alias file is loaded in 
a Soar interpreter automatically.  The \fBalias-soar6.tcl\fR
can be loaded in by one of the Soar init files or at any other 
time a \fBsource\fR command is usable.

.SH SEE ALSO
\fBalias\fR
