'\"
'\" Soar man page 
'\"
.so man.macros
.HS chunky-problem-spaces soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
chunky-problem-spaces \- Manage chunky Soar problem spaces
.SH SYNOPSIS
\fBchunky-problem-spaces \fR[\fB-add\fR \fIspacename\fR | \fB-remove\fR \fIspacename\fR]
.BE

.SH DESCRIPTION
.PP
A chunk is a production that is learned by Soar.  Sometimes learning
chunks is generally problematic for an application.  To mark 
those problem spaces which perform well under chunking, the 
\fBchunky-problem-spaces\fR command can be used.  In these spaces, 
if learning is set as \fBspecify\fR than the learning of chunks 
is enabled.
.PP
This command manages the chunky Soar problem spaces.
With no arguments, this command prints the current list of 
problem spaces declared chunky.  With arguments, it adds 
or removes a given problem space from the chunky problem
space list.  If learning is set to \fBspecify\fR, chunks will
only be built in a problem space declared chunky.

.SH OPTIONS
.TP
\fB-add\fR \fIspacename\fR
Add the \fIspacename\fR to the chunky problem space list.
\fIspacename\fR must be a valid Soar symbol.
.TP
\fB-remove\fR \fIspacename\fR
Remove the \fIspacename\fR from the chunky problem space list.
\fIspacename\fR must be present on the chunky problem space list.
.PP
The \fIspacename\fR must be the name of a Soar problem space.

.SH EXAMPLES
This command declares my-space to be a chunky problem space:
.DS
\fBchunky-problem-spaces -add my-space\fR
.DE
.PP
This command removes my-space from the chunky problem space
list disabling chunks from being built:
.DS
\fBchunky-problem-spaces -remove my-space\fR
.DE

.SH SEE ALSO
\fBlearn\fR, \fBchunk-free-problem-space\fR

