'\"
'\" Soar man page 
'\"
.so man.macros
.HS explain soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
explain \- Interpret chunking backtraces
.SH SYNOPSIS
\fBexplain\fR [\fIname\fR | \fIname\fR \fB-trace\fR | \fIname condition \fR | \fIcondition\fR]
.BE

.SH DESCRIPTION
.PP
This command provides some interpretation of backtraces generated 
during chunking.  If no option is given, then a list of all chunks
and justifications is printed.  
.PP
The two most useful variants are \fBexplain\fR \fIname\fR and
\fBexplain\fR \fIname condition\fR.
The first variant lists all of the conditions for the named
chunk or justification, and the \fIground\fR which resulted in
inclusion in the chunk/justification.  A \fIground\fR is a 
working memory element (WME) which was tested in the supergoal.
Just knowing which WME was 
tested may be enough to explain why the chunk/justification 
exists.  If not, the conditions can be listed with an integer 
value.  This value can be used in \fBexplain\fR \fIname condition\fR 
to obtain a list of the productions which fired to obtain this
condition in the chunk/justification (and the crucial WMEs 
tested along the way).  Why use an integer value to specify the 
condition?  To save a big parsing job.  

.SH OPTIONS
.PP
If an option is given, it must match one of the following forms:
.TP
\fIname\fR
list all conditions and grounds for the chunk or justification named
\fIname\fR
.TP
\fIname\fR \fB-trace\fR
provide a backtrace for the chunk or justification named \fIname\fR
.TP
\fIname condition \fR
explain why condition number \fIcondition\fR is in the chunk or
justification

.SH WARNINGS
.PP
Explain mode must be \fB-on\fR when a chunk or
justification is created or no explanation will be available.
When explain mode is on, more memory is used, and building
chunks and justifications will be slower. 
 


