'\"
'\" Soar man page 
'\"
.so man.macros
.HS go soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
go \- Run Soar
.SH SYNOPSIS
\fBgo\fR [\fIn\fR] [\fIunit\fR]
.BE

.SH DESCRIPTION
.PP
This command runs Soar.  \fIn\fR is a single integer 
which specifies the number of times to run Soar.  If \fIn\fR 
is the single keyword \fBforever\fR, then Soar is run until halted 
by problem-solving completion or an external interrupt.  The
\fIunit\fR argument indicates the unit of measure to be used
in counting Soar run cycles.  \fIunit\fR must be one of the following
keywords:
.TP
\fBp\fR
run Soar for \fIn\fR phases.  A phase is either an input 
phase, preference phase, working memory phase, output 
phase, or decision phase.
.TP
\fBe\fR
run Soar for \fIn\fR elaboration cycles.  (For purposes of 
this command, decision phase is counted as an elaboration cycle.)
.TP
\fBd\fR
run Soar for \fIn\fR decision cycles
.TP
\fBs\fR
run Soar until the \fIn\fRth time a state is selected
.TP
\fBo\fR
run Soar until the \fIn\fRth time an operator is selected
.TP
\fIcontext-variable\fR
run Soar until the \fIn\fRth time a selection is made for 
that particular context slot, or until the context stack pops 
to above that context.  Permissable \fIcontext-variable\fRs include
\fB<s>\fR and \fB<o>\fR, which represent the 
current state and operator, respectively.  The parent
context can be accessed by prefixing \fBs\fR to each of the above 
variables: \fB<ss>\fR and \fB<so>\fR.  \fB<ss>\fR
refers to the superstate.  Finally, the grandparent context
can be accessed by prefixing another \fBs\fR to each of the parent
context variables: \fB<sss>\fR and \fB<sso>\fR.
So \fB<sss>\fR refers to the super-superstate which is the state
in the parent's parent context.
.PP 
The \fBgo\fR command remembers each argument you give it each time.
If you don't give arguments next time, it uses the ones from the 
previous time.

.SH EXAMPLES
Here are several examples \fIin sequence\fR:
.TP
\fBgo 5 d\fR
run for 5 decision cycles
.TP
\fBgo e\fR
run for another 5 elaboration cycles
.TP
\fBgo 1 s\fR
run until the next state is selected (i.e., 
until the next time an impasse arises)
.TP
\fBgo <so>\fR
run until the next superoperator is selected 
(or until the supergoal goes away)
.TP
\fBgo 3 <o>\fR
run for 3 operator selections at this level 
(continuing through any subgoals that arise)
