'\"
'\" Soar man page 
'\"
.so man.macros
.HS learn soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
learn \- Control the learning of productions
.SH SYNOPSIS
\fBlearn\fR [\fIoption\fR*]
.BE

.SH DESCRIPTION
.PP
This command is used to control the learning of productions.  
With no arguments, this command prints out the current learning 
environment status.  The \fBwatch\fR command can be used to
provide various levels of detail when productions are learned.

.SH OPTIONS

Any \fIoption\fRs given must match one of the following keywords:
.TP
\fB-on\fR
turn learning on
.TP
\fB-off\fR
turn all learning off

.TP
\fB-all-goals\fR
when learning is on, this allows learning at all 
goal stack levels (in contrast to bottom-up learning)
.TP
\fB-bottom-up\fR
when learning is on, this allows learning at only 
the lowest goal stack level; i.e., a chunk is 
learned at a given level only if no chunk has yet 
been learned at a lower level.

.TP
\fB-noprint\fR
equivalent to \fBwatch -chunk-names off -chunks off\fR
.TP
\fB-print\fR
equivalent to \fBwatch -chunk-names on -chunks off\fR
.TP
\fB-full-print\fR
equivalent to \fBwatch -chunk-names on -chunks on -justification-names
on -justifications on\fR
.TP
\fB-no-trace\fR
equivalent to \fBwatch -firings chunk off -backtracing off\fR
.TP
\fB-trace\fR
equivalent to \fBwatch -firings chunk on -backtracing off\fR
.TP
\fB-full-trace\fR
equivalent to \fBwatch -firings chunk on -backtracing on -chunk-names
on -chunks on -justification-names on -justifications on\fR

.SH WARNINGS
Individual problem spaces may be set to
disallow learning -- see the \fBchunk-free-problem-spaces\fR command
for more information.  

.SH SEE ALSO
\fBchunk-free-problem-spaces\fR, \fBwatch\fR

