'\"
'\" Soar man page 
'\"
.so man.macros
.HS print soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
print \- Print a Soar object
.SH SYNOPSIS
\fBprint\fR [ \fB-depth\fR \fIn\fR] [ \fB-internal\fR ] [\fIitem\fR*]
.br
\fBprint\fR -stack [ \fB-goal\fR | \fB-operator\fR ]*
.BE

.SH DESCRIPTION
.PP
The \fBprint\fR command is used to print items from production 
memory or working memory.  The \fIitem\fRs to be printed may be
one of the following:
.TP
\fIproduction-name\fR
print the production named \fIproduction-name\fR
.TP
\fIidentifier\fR
print the object \fIidentifier\fR.  \fIidentifier\fR must be a
valid Soar symbol.
.TP
\fIinteger\fR
print the working memory element with the timetag \fIinteger\fR
.TP
\fIpattern\fR
print the working memory elements matching the given \fIpattern\fR.
The pattern is interpreted by the Soar kernel so it must be surrounded
by curly braces or double quotes to avoid being parsed by Tcl.  A
\fIpattern\fR has the following form:
.DS
       \fB(\fIidentifier \fB^\fIattribute value\fR\fR [\fB\fB+\fR]\fB)\fR
.DE
.PP
The \fIpattern\fR is surrounded by parentheses.  The \fIidentifier\fR,
\fIattribute\fR, and \fIvalue\fR must be valid Soar symbols or the
wildcard symbol \fB*\fR which matches all occurences.  The optional
\fB+\fR symbol restricts pattern matches to acceptable preferences.

.SH OPTIONS
.PP
.TP
\fB-depth\fR \fIn\fR 
This option overrides the default
printing depth (see the \fBdefault-print-depth\fR command for more
detail).  Note that a \fB-depth 0\fR argument is meaningful only with
accompanying integer and pattern arguments.  It causes only the 
matching working memory elements to be printed, instead of all 
elements whose identifier is an identifier in one of the matching 
working memory elements.
.TP
\fB-internal\fR 
Specifies that objects should be printed 
in their internal form.  For productions, this means leaving 
conditions in their reordered (rete net) form.  For working memory
elements, this means printing the individual elements with their 
timetags, rather than the objects.
.TP
\fB-stack\fR
Specifies that the Soar goal stack should be printed.  By default
this includes both goals and operators.  The stack listing can
be restricted by adding the \fB-goal\fR and \fB-operator\fR
restrictions.  Giving both options is equivalent to the default.

.SH EXAMPLES
.TP
\fBprint -internal {(s1 ^* v2)}\fR
Print the working memory elements (and their timetags) which have
the identifier s1 as object and v2 as value.
.TP
\fBprint -stack\fR
Print the Soar goal stack which includes goal states and operators.

.SH SEE ALSO
\fBdefault-print-depth\fR









