'\"
'\" Soar man page 
'\"
.so man.macros
.HS schedule-interp soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
schedule-interp \- Setup a script to be run in the Soar scheduler
.SH SYNOPSIS
\fBschedule-interp\fR \fB-add\fR | \fB-remove\fR \fB-before\fR | \fB-after\fR [\fIname\fR \fIscript\fR]
.BE

.SH DESCRIPTION
.PP
This command schedules a script to be run in a specified interpreter
when the Soar scheduler runs.  At most, two scripts may be posted: one
to run before all the Soar agents in a schedule cycle and another to
run after.  Posted scripts may also be removed. 
.PP
The first argument to this command is the option to add or remove
a script from the Soar scheduler:
.TP
\fB-add\fR
Add a script to the scheduler cycle.
.TP
\fB-remove\fR
Remove a script from the scheduler cycle.
.PP
The second argument specifies which of the two Soar scheduler events
applies:
.TP
\fB-before\fR
The script applies to the point in the Soar scheduler just before
all the agents are run in a given cycle.
.TP
\fB-after\fR
The script applies to the point in the Soar scheduler just after
all the agents have been run in a given cycle.
.PP
If the \fB-add\fR action has been given, then both a \fIname\fR and
\fIscript\fR must be given (nothing is given in the \fB-remove\fR
case).  The \fIname\fR must be the name of an existing interpreter.
The \fIscript\fR can be any Tcl script.

.SH EXAMPLES
This command is primarily intended to make it easy to use a Tcl
simulator in a non-agent interpreter with a set of Soar agents.  
Hence, if an interpreter named \fBsim\fR contains a simulator 
written in Tcl and the procedure \fBTickSim\fR updates the simulator, 
then the following command would schedule the simulator so that it 
would be ticked after agents are run in each schedule cycle. 
.DS
\fBschedule-interp -add -after sim TickSim\fR
.DE

.SH SEE ALSO
\fBschedule\fR
