'\"
'\" Soar man page 
'\"
.so man.macros
.HS watch soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
watch \- Run-time tracing of Soar
.SH SYNOPSIS
\fBwatch\fR [\fIoption\fR*]
.BE
.SH DESCRIPTION
.PP
The \fBwatch\fR command controls run-time tracing of Soar.
With no arguments, this command prints out the current watch 
status.  
The various \fIoption\fRs are used to modify the current watch
settings.  For example, \fBwatch -context on\fR turns on the 
tracing of context slot decisions; \fBwatch -context off\fR 
turns it off again.  Individual watch parameters may be changed
using this command as well as sets of parameters defined by
\fBwatch\fR levels.  The \fBlearn\fR command may also be used to
alter certain watch settings.

.SH OPTIONS
.PP
The following options are allowed (\fIstatus\fR
must be given as either \fBon\fR or \fBoff\fR):
.TP
\fB-context\fR \fIstatus\fR 
controls whether context slot decisions are printed
.TP
\fB-phases\fR \fIstatus\fR
controls whether phase names are printed
.TP
\fB-firings\fR [ \fBdefault\fR | \fBuser\fR | \fBchunk\fR | \fBnonchunk\fR | \fBall\fR ] \fIstatus\fR
\fRcontrols which 
production firings and retractions are printed.  The 
optional argument (which defaults to \fBall\fR) specifies 
which types of productions the \fIstatus\fR argument refers to.
.TP
\fB-firings-wmes\fR [ \fB0\fR | \fB1\fR | \fB2\fR ]
controls the level of detail given about the 
wmes matched by productions whose firings and 
retractions are being traced.  Level 0 means no 
information about the wmes is printed.  Level 1 means 
the wme timetags are printed.  Level 2 means the whole 
wmes are printed.
.TP
\fB-firings-preferences\fR \fIstatus\fR
controls whether the preferences 
generated by the traced productions are printed when 
those productions fire or retract.  When a production 
fires, all the preferences it generates are printed.  
When it retracts, only the ones being removed from
preference memory are printed (i.e., the i-supported ones).
.TP
\fB-wmes\fR \fIstatus\fR
controls whether changes to working memory are printed
.TP
\fB-chunk-names\fR \fIstatus\fR
controls whether names of newly built chunks are printed
.TP
\fB-justification-names\fR \fIstatus\fR
ditto, only for justifications (internal chunks)
.TP
\fB-chunks\fR \fIstatus\fR
controls whether newly built chunks are printed
.TP
\fB-justifications\fR \fIstatus\fR
ditto, only for justifications
.TP
\fB-backtracing\fR \fIstatus\fR
controls whether backtracing information is printed
.PP
The options above allow complete control over individual watch
settings.  Some settings are often manipulated together and
an aggregrate scheme has been generated to help make this process
easier.  Hence, a \fBwatch\fR \fIoption\fR can also be one of the
following numeric arguments: \fB-1, 0, 0.5, 1, 1.5, 2, 3\fR.
The table below gives the corresponding option parameter settings
for each numeric argument:
.DS
            Watch Level:    -1    0  0.5    1  1.5    2    3
                           ---- ---- ---- ---- ---- ---- ----
  -context                 off   on   on   on   on   on   on
  -phases                  off  off   on   on   on   on   on
  -firings nonchunk        off  off   on   on   on   on   on
    -firings-wmes            0    0    0    1    2    2    2
    -firings-preferences   off  off  off  off  off  off   on
  -wmes                    off  off  off  off  off   on   on
.DE
.PP
\fBwatch task\fR is also provided and is equivalent to \fBwatch -firings default off\fR.
.PP
\fBlearn noprint\fR/\fBprint\fR/\fBfull-print\fR and \fBnotrace\fR/\fBtrace\fR/\fBfull-trace\fR also 
translate into keyword parameter settings, as shown in the tables 
below:
.DS
          Learn:   noprint  print  full-print
                   -------  -----  ----------
  -chunk-names        off     on          on
  -chunks             off    off          on

          Learn:   notrace  trace  full-trace
                   -------  -----  ----------
  -firings chunk      off     on          on
  -backtracing        off    off          on
.DE
.PP

.SH EXAMPLES
The most common uses of \fBwatch\fR are by using the numeric arguments
which indicate \fBwatch\fR levels:
.DS
\fBwatch 0\fR
.DE
.PP
or
.DS
\fBwatch 3\fR
.DE
.PP
Of course, individual options can be changed as well:
.DS
\fBwatch 1 -justifications off -chunks on\fR
.DE

.SH SEE ALSO
\fBlearn\fR, \fBptrace\fR

