

#ifndef __GEO_H
#define __GEO_H

#ifndef __GEO_EXTERN
#define __GEO_EXTERN extern
#endif

#include "robocup.h"
#include <math.h>

#define Rad2Deg(x)  ((double)(x) * 180.0 / M_PI)
#define Deg2Rad(x)  ((double)(x) * M_PI / 180.0)

#define min(a,b)  ((a) > (b) ? (b) : (a))
#define abs(a)    ((a) < 0 ? -(a) : (a))

#define PROBLEM_ANGLE 130

#define FIELD_LENGTH  105.0
#define GOAL_WIDTH     14.02

__GEO_EXTERN int estimate_object_pos(ObjInfo *);
__GEO_EXTERN double NormalizeAngle(double);


#endif
