#!/bin/csh -f

# This command requires the script ISIS.sh in the users home directory

set MHOST = `hostname`
set myhostname  = "`expr $MHOST : '\([^\.]*\)'`" 
set MYPATH = /nfs/etg/netouchepas/robocup/ISI-1/soar-7.0.0.beta
setenv TCL_DIR  /nfs/etg/netouchepas/robocup/ISI-1
setenv TCL_LIBRARY $TCL_DIR/tcl7.4/library
setenv TK_LIBRARY $TCL_DIR/tk4.0/library
setenv SOAR_LIBRARY $TCL_DIR/soar-7.0.0.beta/library

if ("$#argv" == "0") then
        echo "Usage:  $0 <host-name> <team> <portnum> <machines>"
        set host = $myhostname
        set teamname = "ISIS"
	set portnum  = 6000
        set machines = ( $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname )
else if ("$#argv" == "1" ) then
        echo "Usage:  $0 <host-name> <team> <portnum>"
        set host = $1
        set teamname = "ISIS"
	set portnum  = 6000
        set machines = ( $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname )
else if ("$#argv" == "2" ) then
        echo "Usage:  $0 <host-name> <team> <portnum>"
        set host = $1
        set teamname = $2
	set portnum  = 6000
        set machines = ( $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname )
else if ("$#argv" == "3" ) then
        set host = $1
        set teamname = $2
        set portnum  = $3
        set machines = ( $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname $myhostname )
else if ("$#argv" == "14" ) then
        set host = $1
        set teamname = $2
        set portnum  = $3
        set machines = ( $4 $5 $6 $7 $8 $9 $10 $11 $12 $13 $14 )
else
        echo "Usage:  $0 <host-name> <team> <portnum>"
        exit -1
endif


echo "Running with the following parameters"
echo "Hostname: " $host
echo "Team: " $teamname
echo "Port: " $portnum
echo "Machines: " $machines

set player_num = 1

foreach POS (ISI-c ISI-ft ISI-fc ISI-fb ISI-ct ISI-cb ISI-bb ISI-bt)
echo Next Machine: $machines[${player_num}]
if ("$machines[${player_num}]" == $myhostname) then
#   set command = "xterm -e "
   set command = ""
else
#    set command = ( xrsh -n $machines[${player_num}] )
    set command = ( rsh -n $machines[${player_num}] )
endif
#$command $HOME/ISIS.sh -robocup-server $host -robocup-teamname $teamname -robocup-port $portnum -agent $POS &
$command $MYPATH/ISIS.sh -robocup-server $host -robocup-teamname $teamname -robocup-port $portnum -agent $POS &
echo "Player $player_num $POS Started"
@ player_num += 1
#sleep 10
sleep 3
end

foreach POS (ISI-sweepert ISI-sweeperb ISI-Goalee)
echo Next Machine: $machines[${player_num}]
if ("$machines[${player_num}]" == $myhostname) then
   set command = ""
else
   set command = ( rsh -n $machines[${player_num}] )
endif
#${command} $HOME/ISIS.sh -robocup-server $host -robocup-teamname $teamname -robocup-port $portnum -robocup-role goalee -agent $POS &
${command} $MYPATH/ISIS.sh -robocup-server $host -robocup-teamname $teamname -robocup-port $portnum -robocup-role goalee -agent $POS &
echo "Player $player_num Started"
@ player_num += 1
#sleep 10
sleep 3
end

waitforq

foreach m ( $machines )
echo $m
rsh -n $m /bin/kill `/usr/ucb/ps ax | grep soar | grep -v grep | awk '{print $1}'`
rsh -n $m /bin/kill `ps ax | grep soar | grep -v grep | awk '{print $1}'`
end




