#include "defns.i"
#include "types.i"
#include "extern.i"

#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#define  Space(s)	(s == ' ' || s == '\n' || s == '\t')
#define  SkipComment	while ( ( c = sgetc() ) != '\n' )

char Delimiter;

char* pszInString;
char* pszInStringSafeCopy = NULL;


void SetInputString( pszString )
     char* pszString;
{
  pszInStringSafeCopy = pszInString = strdup( pszString );
}




int sgetc()
{
  int retVal;
  char c = EOF;

  if( pszInStringSafeCopy != NULL )
    {
      if ( pszInString[0] == '\0' ) 
	{
	  free( pszInStringSafeCopy );
	  pszInStringSafeCopy = NULL;
	  c = EOF;
	}
      else
	{
	  retVal = sscanf( pszInString, "%c", &c );
	  if( retVal != 1)
	    {
	      printf("\nERROR: \"sgetc()\" failed to read from pszInStrin!!!\n\n");
	      return EOF;
	    }
	  pszInString++;
	}
    }

  return c;
}




/*************************************************************************/
/*									 */
/*************************************************************************/


Boolean sReadName(s)
     String s;
{
    register char *Sp=s;
    register int c;
    String CopyString();


    /*  Skip to first non-space character  */

    while ( ( c = sgetc() ) == '|' || Space(c) )
    {
	if ( c == '|' ) SkipComment;
    }

    /*  Return false if no names to read  */

    if ( c == EOF )
    {
	Delimiter = EOF;
	return false;
    }

    /*  Read in characters up to the next delimiter  */

    while ( c != ':' && c != ',' && c != '\n' && c != '|' && c != EOF )
    {
	if ( c == '.' )
	{
	    if ( ( c = sgetc() ) == '|' || Space(c) ) break;
	    *Sp++ = '.';
	}

	if ( c == '\\' )
	{
	    c = sgetc();
	}

	*Sp++ = c;

	if ( c == ' ' )
	{
	    while ( ( c = sgetc() ) == ' ' )
		;
	}
	else
	{
	    c = sgetc();
	}
    }

    if ( c == '|' ) SkipComment;
    Delimiter = c;

    /*  Strip trailing spaces  */

    while ( Space(*(Sp-1)) ) Sp--;

    *Sp++ = '\0';

    return true;
}
