#include <soar.h>

/* Global vars */
extern Symbol * space_to_remove_from_cfps;

/* Function prototypes */
extern void add_multi_attribute_or_change_value(char *sym, long val);
extern bool cfps_removal_test_function (cons *c);
extern int  compare_firing_counts (const void * e1, const void * e2);
extern unsigned long count_rete_tokens_for_production (production *prod);
extern void do_print_for_identifier (Symbol *id, int depth, bool internal);
extern void do_print_for_production_name (char *prod_name, bool internal);
extern void do_print_for_wme (wme *w, int depth, bool internal);
extern void excise_all_productions_of_type (byte type);
extern void execute_go_selection (agent * the_agent,
				  long go_number, 
				  enum go_type_enum go_type,
				  Symbol * go_slot_attr, 
				  goal_stack_level go_slot_level);
extern void get_context_var_info (Symbol **dest_goal,
				  Symbol **dest_attr_of_slot,
				  Symbol **dest_current_value);
extern void get_lexeme_from_string (char * the_lexeme);
extern void install_tcl_soar_cmd (agent *, char *, Tcl_CmdProc *);
extern bool is_production_name (char *);
extern production * name_to_production (char * string_to_test);
extern void neatly_print_wme_augmentation_of_id (wme *w, int indentation);
extern int parse_go_command (Tcl_Interp * interp, int argc, char * argv[],
			     long * go_number, enum go_type_enum * go_type,
			     Symbol * * go_slot_attr, 
			     goal_stack_level * go_slot_level);
extern int  parse_memory_stats (Tcl_Interp * interp, 
				int argc, char * argv[]);
extern int  parse_rete_stats (Tcl_Interp * interp, int argc, char * argv[]);
extern int  parse_system_stats (Tcl_Interp * interp, 
				int argc, char * argv[]);
extern void print_augs_of_id (Symbol *id, int depth, bool internal,
			      int indent, tc_number tc);
extern void print_current_learn_settings(void);
extern void print_current_watch_settings (void);
extern void print_memories (int num_to_print, int to_print[]);
extern void print_preference_and_source (preference *pref,
					 bool print_source,
					 wme_trace_type wtt);
extern int  print_production_firings (Tcl_Interp * interp, 
				      int num_requested);
extern int read_id_or_context_var_from_string (char * the_lexeme, Symbol **);
extern Symbol *read_identifier_or_context_variable (void);
extern void read_pattern_and_get_matching_productions (list **current_pf_list,
						       bool show_bindings,
						       bool just_chunks,
						       bool no_chunks);
extern list *read_pattern_and_get_matching_wmes (void);
extern int read_pattern_component (Symbol **dest_sym);
extern void read_rhs_pattern_and_get_matching_productions (list **pf_list, 
							   bool show_bindings,
							   bool just_chunks, 
							   bool no_chunks);
extern int set_watch_setting (Tcl_Interp * interp, int dest_sysparam_number, 
			      char * param, char * arg);
extern bool soar_agent_already_defined (char *);
extern void soar_callback_to_tcl (soar_callback_agent,
				  soar_callback_data,
				  soar_call_data);
extern bool string_match (char *, char *);
extern bool string_match_up_to (char *, char *, int);

extern void soar_input_callback_to_tcl (soar_callback_agent the_agent, 
					soar_callback_data data,
					soar_call_data call_data);
extern void soar_output_callback_to_tcl (soar_callback_agent the_agent, 
					 soar_callback_data data,
					 soar_call_data call_data);
