/*  
    The schedule_agents function is the entry point to the multi-agent
    soar scheduler.  A round robin scheduling protocol is used for now.

    In a cycle all agents are run for their specified "agent-go" duration
    and the X-window event queue is processed (if applicable).  The allowed
    values for input are some nuber of cycles.  With an input of -1, the
    scheduler continues until all agents are stopped.  This may happen
    in normal agent processing termination or through a user interrupt.
*/

typedef struct {
  Tcl_Interp * interp;
  char * script;
} Soar_ScheduledInterp;

extern Soar_ScheduledInterp Soar_BeforeSchedule;
extern Soar_ScheduledInterp Soar_AfterSchedule;

extern long scheduler_cycle_count;

extern int schedule_agents (Tcl_Interp * interp, int cycles);
