/*************************************************************************/
/*								 	 */
/*	User interface for consulting trees and rulesets	 	 */
/*	------------------------------------------------	 	 */
/*								 	 */
/*************************************************************************/



#include "defns.i"
#include "types.i"
#include "extern.i"


typedef	struct	ValRange	*RangeDescRec;
struct	ValRange
	{
	    Boolean		Known, Asked;
	    float		LowerBound, UpperBound, *Probability;
	};


extern	RangeDescRec		RangeDesc;
extern  ItemNo                  cCurrentItem;

#define Fuzz 0.01


/*************************************************************************/
/*									 */
/*	Ask for the value of attribute Att if necessary			 */
/*									 */
/*************************************************************************/


CheckValue(Att)
     Attribute Att;
{
  if ( RangeDesc[Att].Asked ) 
    return;

  ReadRange(Att);
}


 

/*************************************************************************/
/*									 */
/*	Read a range of values for attribute Att         		 */
/*									 */
/*************************************************************************/


ReadRange(Att)
     Attribute Att;
{
  RangeDesc[Att].Asked=true;
  RangeDesc[Att].Known = true;
  
  if ( MaxAttVal[Att] )
    ReadDiscr(Att);
  else
    ReadContin(Att);
}



/*************************************************************************/
/*									 */
/*	Read a discrete attribute value or range			 */
/*									 */
/* [IonM]:                                                               */
/* +++++++      							 */
/*									 */
/*	a) check input validity !!!       				 */
/*      b) treat general case (pairs Val:Probab)   			 */
/*									 */
/*************************************************************************/

ReadDiscr(Att)
     Attribute Att;
{
  DiscrValue dv;

  /* [IonM] */
  /* SUPER BUG: here it crashes for DISCRETE values */
  ForEach(dv, 1, MaxAttVal[Att])
    {
      RangeDesc[Att].Probability[dv] = 0.0;
    }

  dv = DVal(Item[cCurrentItem], Att);

  RangeDesc[Att].Probability[dv] = 1.0;
}









/*************************************************************************/
/*									 */
/*	Read a continuous attribute value or range			 */
/*									 */
/*************************************************************************/


ReadContin(Att)
     Attribute Att;
{
  float cv;

  cv = CVal(Item[cCurrentItem], Att);
  RangeDesc[Att].UpperBound = RangeDesc[Att].LowerBound = cv;
}




/*************************************************************************/
/*									 */
/*		Clear the range description				 */
/*									 */
/*************************************************************************/

    Clear()
/*  -----  */
{
    Attribute Att;

    ForEach(Att, 0, MaxAtt)
    {
	RangeDesc[Att].Known = false;
    }
}

























